<?php

/**
 * webEdition CMS
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package    webEdition_language
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */


/**
 * Language file: export.inc.php
 * Provides language strings.
 * Language: English
 */
$l_export["save_changed_export"] = "Export has been changed.\\nDo you want to save your changes?";
$l_export["auto_selection"] = "Automatic selection";
$l_export["txt_auto_selection"] = "Exports documents or objects automatically according to document type or class.";
$l_export["txt_auto_selection_csv"] = "Exports objects automatically according to their class.";
$l_export["manual_selection"] = "Manual selection";
$l_export["txt_manual_selection"] = "Exports manually selected documents or objects.";
$l_export["txt_manual_selection_csv"] = "Exports manually selected objects.";
$l_export["element"] = "Element selection";
$l_export["documents"] = "Documents";
$l_export["objects"] = "Objects";
$l_export["step1"] = "Select parameters";
$l_export["step2"] = "Select items to export";
$l_export["step3"] = "Select export parameters";
$l_export["step10"] = "Export finished";
$l_export["step99"] = "Error while exporting";
$l_export["step99_notice"] = "Export not possible";
$l_export["server_finished"] = "The export file has been saved on the server.";
$l_export["backup_finished"] = "The export was successful.";
$l_export["download_starting"] = "Download of the export file has been started.<br><br>If the download does not start after 10 seconds,<br>";
$l_export["download"] = "please click here.";
$l_export["download_failed"] = "Either the file you requested does not exist or you are not permitted to download it.";
$l_export["file_format"] = "File format";
$l_export["export_to"] = "Export to";
$l_export["export_to_server"] = "Server";
$l_export["export_to_local"] = "Local harddisc";
$l_export["cdata"] = "Coding";
$l_export["export_xml_cdata"] = "Add CDATA sections";
$l_export["export_xml_entities"] = "Replace entities";
$l_export["filename"] = "File name";
$l_export["path"] = "Path";
$l_export["doctypename"] = "Documents of document type";
$l_export["classname"] = "Objects of class";
$l_export["dir"] = "Directory";
$l_export["categories"] = "Categories";
$l_export["wizard_title"] = "Export Wizard";
$l_export["xml_format"] = "XML";
$l_export["csv_format"] = "CSV";
$l_export["csv_delimiter"] = "Delimiter";
$l_export["csv_enclose"] = "Enclose character";
$l_export["csv_escape"] = "Escape character";
$l_export["csv_lineend"] = "File format";
$l_export["csv_null"] = "NULL replacement";
$l_export["csv_fieldnames"] = "Put field names in first row";
$l_export["windows"] = "Windows format";
$l_export["unix"] = "UNIX format";
$l_export["mac"] = "Mac format";
$l_export["generic_export"] = "Generic export";
$l_export["title"] = "Export Wizard";
$l_export["gxml_export"] = "Generic XML export";
$l_export["txt_gxml_export"] = "Export webEdition documents and objects to a \"flat\" XML file (3 levels).";
$l_export["csv_export"] = "CSV export";
$l_export["txt_csv_export"] = "Export webEdition objects to a CSV file (comma separated values).";
$l_export["csv_params"] = "Settings";
$l_export["error"] = "The export process was not successful!";
$l_export["error_unknown"] = "An unknown error occured!";
$l_export["error_object_module"] = "The export of documents into CSV files is currently not supported!<br><br>Because the DB/Object Module is not installed, exporting CSV files is not available.";
$l_export["error_nothing_selected_docs"] = "The export has not been executed!<br><br>No documents were selected.";
$l_export["error_nothing_selected_objs"] = "The export has not been executed!<br><br>No documents or objects were selected.";
$l_export["error_download_failed"] = "Download of the export file failed.";
$l_export["comma"] = ", {comma}";
$l_export["semicolon"] = "; {semicolon}";
$l_export["colon"] = ": {colon}";
$l_export["tab"] = "\\t {tab}";
$l_export["space"] = "  {space}";
$l_export["double_quote"] = "\" {double quote}";
$l_export["single_quote"] = "' {single quote}";
$l_export['we_export'] = 'webEdition export';
$l_export['wxml_export'] = 'webEdition XML export';
$l_export['txt_wxml_export'] = 'Export of webEdition documents, templates, objects and classes corresponding to the webEdition specific DTD (document type definition).';

$l_export['options'] = 'Options';
$l_export['handle_document_options'] = 'Documents';
$l_export['handle_template_options'] = 'Templates';
$l_export['handle_def_templates'] = 'Export default templates';
$l_export['handle_document_includes'] = 'Export included documents';
$l_export['handle_document_linked'] = 'Export linked documents';
$l_export['handle_object_options'] = 'Objects';
$l_export['handle_def_classes'] = 'Export default classes';
$l_export['handle_object_includes'] = 'Export included objects';
$l_export['handle_classes_options'] = 'Classes';
$l_export['handle_class_defs'] = 'Default value';
$l_export['handle_object_embeds'] = 'Export embedded objects';
$l_export['handle_doctype_options'] = 'Doctypes/<br>Categories/<br>Navigation';
$l_export['handle_doctypes'] = 'Doctypes';
$l_export['handle_categorys'] = 'Categories';
$l_export['export_depth'] = 'Export depth';
$l_export['to_level'] = 'to level';
$l_export['select_export'] ='To export an entry, please mark the referring check box in the tree. Important note: All marked items from all branches will be exported and if you export a directory all documents in this directory will be exported as well!';
$l_export['templates'] = 'Templates';
$l_export['classes'] = 'Classes';

$l_export['nothing_to_delete'] = 'Nothing to delete.';
$l_export['nothing_to_save'] = 'Nothing to save!';
$l_export['no_perms'] = 'No permissions!';
$l_export['new'] = 'New';
$l_export['export'] = 'Export';
$l_export['group'] = 'Group';
$l_export['save'] = 'Save';
$l_export['delete'] = 'Delete';
$l_export['quit'] = 'Close';
$l_export['property'] = 'Property';
$l_export['name'] = 'Name';
$l_export['save_to'] = 'Save to:';
$l_export['selection'] = 'Selection';
$l_export['save_ok'] = 'Export has been saved.';
$l_export['save_group_ok'] = 'Group has been saved.';
$l_export['log'] = 'Details';
$l_export['start_export'] = 'Start export';
$l_export['prepare'] = 'Prepare export...';
$l_export['doctype'] = 'Document-Type';
$l_export['category'] = 'Category';
$l_export['end_export'] = 'Export finished';
$l_export['newFolder'] = "New Group";
$l_export['folder_empty'] = "Folder is empty!";
$l_export['folder_path_exists'] = "Folder already exists!";
$l_export['wrongtext'] = "Name is not valid";
$l_export['wrongfilename'] = "The filename is not valid!";
$l_export['folder_exists'] = "Folder already exists";
$l_export['delete_ok'] = 'The export has beed deleted.';
$l_export['delete_nok'] = 'ERROR: The export has not beed deleted';
$l_export['delete_group_ok'] = 'The group has beed deleted.';
$l_export['delete_group_nok'] = 'ERROR: The group has not beed deleted';
$l_export['delete_question'] = 'Do you want to delete the current export?';
$l_export['delete_group_question'] = 'Do you want to delete the current group?';
$l_export['download_starting2'] = 'Download of the export file has been started.';
$l_export['download_starting3'] = 'If the download does not start after 10 seconds,';
$l_export['working'] = 'Working';

$l_export['txt_document_options'] = 'The default template is the template that is defined in the document properties. The included documents are internal documents that are included in the export document with the the tags we:include, we:form, we:url, we:linkToSeeMode, we:a, we:href, we:link, we:css, we:js and we:addDelNewsletterEmail. The included objects are objects that are included in the export document with the tags we:object and we:form. The linked documents are internal documents that are linked with the export document with the HTML tags body, a, img, table and td.';
$l_export['txt_object_options'] = 'The default class is the class that is defined in the object properties. To export in the object included internal documents e.g. images, please activate the option "Export included documents".';
$l_export['txt_exportdeep_options'] = 'The export deep defines the level for the export of the included documents. The field must be a number!';
$l_export['name_empty'] = 'The name cannot be empty!';
$l_export['name_exists'] = 'The name already exists!';

$l_export['help'] = 'Help';
$l_export['info'] = 'Info';
$l_export['path_nok'] = 'The path is not correct!';

$l_export['must_save'] = "The export has been changed.\\nYou must save the export data before you can do the export!";
$l_export['handle_owners_option'] = 'Owners data';
$l_export['handle_owners'] = 'Export owners data';
$l_export['txt_owners'] = 'Export linked owners data.';

$l_export['weBinary'] = 'File';
$l_export['handle_navigation'] = 'Navigation';
$l_export['weNavigation'] = 'Navigation';
$l_export['weNavigationRule'] = 'Navigation rule';
$l_export['weThumbnail'] = 'Thumbnails';
$l_export['handle_thumbnails'] = 'Thumbnails';

$l_export['navigation_hint'] = 'Document types, categories and the navigation are exported depending on your select documents and templates. The export of the navigation therefore requires the export of a template with a document based on it in which the navigation is used.';

?>